cmake_minimum_required(VERSION 3.2)

function(download_boost version)
    find_file(cwd DownloadBoost.cmake PATHS ${CMAKE_MODULE_PATH})
    get_filename_component(cwd "${cwd}" DIRECTORY)
    file(TO_CMAKE_PATH "${cwd}/../bin/boost-lib" boost-lib)
    message(STATUS "Invoking boost-lib to download Boost ${version}.")
    execute_process(COMMAND node "${boost-lib}" download "-V=${version}" RESULT_VARIABLE err OUTPUT_VARIABLE path)
    if(err)
        message(FATAL_ERROR "Download error.")
    endif(err)
    string(STRIP "${path}" path)
    file(TO_CMAKE_PATH "${path}" path)
    set(install_dir ${path} PARENT_SCOPE)
endfunction(download_boost)